#include<iostream>
#include<cmath>
using namespace std;
int main(){
long n,m,b[100000],a[200000],x,c;
	cin>>n>>m;
	for(int i=1;i<=m;i++){
		cin>>b[i];
	}
	cin>>c;
	for(int i=1;i<=n;i++)a[i]=i;
	for(int i=0;i<=n-m;i++)
	for (int j=1; j<=m; j++)
    a[i + b[j]] = a[i + j];
	for(int i=1;i<=n;i++)
	x=x+pow(c,i)*a[i];
	cout<<x;
}